package net.sf.alchim.mojo.yuicompressor;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;

import org.codehaus.plexus.util.DirectoryScanner;
import org.codehaus.plexus.util.IOUtil;

public class Aggregation {
    public File output;
    public String[] includes;
    public String[] excludes;
    public boolean removeIncluded = false;
    public boolean insertNewLine = false;

    public void run() throws Exception {
        DirectoryScanner scanner = new DirectoryScanner();
        scanner.setBasedir(output.getParentFile());
        if (includes != null) {
            scanner.setIncludes(includes);
            if ((excludes != null) && (excludes.length != 0)) {
                scanner.setExcludes(excludes);
            }
            scanner.addDefaultExcludes();
            scanner.scan();
            String[] files = scanner.getIncludedFiles();
            if (files.length != 0) {
                FileOutputStream out = new FileOutputStream(output);
                try {
                    for (String fileRPath : files) {
                        File file = new File(output.getParentFile(), fileRPath);
                        FileInputStream in = new FileInputStream(file);
                        try {
                            IOUtil.copy(in, out);
                            if (insertNewLine) {
                                out.write('\n');
                            }
                            if (removeIncluded) {
                                file.delete();
                            }
                        } finally {
                            IOUtil.close(in);
                            in = null;
                        }
                    }
                } finally {
                    IOUtil.close(out);
                    out = null;
                }
            }
        } else {

        }
    }
}
